<template>
  <v-dialog v-model="dialog" max-width="500">
    <v-card>
      <v-card-title class="headline">Add Product to Group</v-card-title>

      <v-card-text>
        <v-form>
          <v-list>
            <product-selector v-model="product_id"/>
          </v-list>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>

        <v-btn color="red darken-1" flat="flat" @click="dialog = false" :loading="loading">Cancel</v-btn>
        <v-btn
          color="green darken-1"
          flat="flat"
          @click="addProduct(); dialog = false"
          :loading="loading"
        >Agree</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import gql from "graphql-tag";
import { QrcodeStream } from "vue-qrcode-reader";
import FindCard from "@/components/FindCard";
import ProductSelector from "@/components/selector/ProductSelector";

export default {
  components: { QrcodeStream, FindCard, ProductSelector },
  props: {
    id: { type: String, required: true }
  },
  data() {
    return {
      product_id: null,
      dialog: false,
      loading: false
    };
  },
  methods: {
    open() {
      this.dialog = true;
    },
    async addProduct() {
      this.loading = true;

      try {
        await this.$apollo.mutate({
          mutation: gql`
            mutation($id: ID!, $product_id: ID!) {
              productGroupAdd(id: $id, product_id: $product_id) {
                id
              }
            }
          `,
          variables: {
            id: this.id,
            product_id: this.product_id
          }
        });
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    }
  }
};
</script>
